<?php

namespace wsas\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfObjetoAsistencia ArrayType
 * @subpackage Arrays
 */
class ArrayOfObjetoAsistencia extends AbstractStructArrayBase
{
    /**
     * The ObjetoAsistencia
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \wsas\StructType\ObjetoAsistencia[]
     */
    public $ObjetoAsistencia;
    /**
     * Constructor method for ArrayOfObjetoAsistencia
     * @uses ArrayOfObjetoAsistencia::setObjetoAsistencia()
     * @param \wsas\StructType\ObjetoAsistencia[] $objetoAsistencia
     */
    public function __construct(array $objetoAsistencia = array())
    {
        $this
            ->setObjetoAsistencia($objetoAsistencia);
    }
    /**
     * Get ObjetoAsistencia value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \wsas\StructType\ObjetoAsistencia[]|null
     */
    public function getObjetoAsistencia()
    {
        return isset($this->ObjetoAsistencia) ? $this->ObjetoAsistencia : null;
    }
    /**
     * Set ObjetoAsistencia value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \wsas\StructType\ObjetoAsistencia[] $objetoAsistencia
     * @return \wsas\ArrayType\ArrayOfObjetoAsistencia
     */
    public function setObjetoAsistencia(array $objetoAsistencia = array())
    {
        foreach ($objetoAsistencia as $arrayOfObjetoAsistenciaObjetoAsistenciaItem) {
            // validation for constraint: itemType
            if (!$arrayOfObjetoAsistenciaObjetoAsistenciaItem instanceof \wsas\StructType\ObjetoAsistencia) {
                throw new \InvalidArgumentException(sprintf('The ObjetoAsistencia property can only contain items of \wsas\StructType\ObjetoAsistencia, "%s" given', is_object($arrayOfObjetoAsistenciaObjetoAsistenciaItem) ? get_class($arrayOfObjetoAsistenciaObjetoAsistenciaItem) : gettype($arrayOfObjetoAsistenciaObjetoAsistenciaItem)), __LINE__);
            }
        }
        if (is_null($objetoAsistencia) || (is_array($objetoAsistencia) && empty($objetoAsistencia))) {
            unset($this->ObjetoAsistencia);
        } else {
            $this->ObjetoAsistencia = $objetoAsistencia;
        }
        return $this;
    }
    /**
     * Add item to ObjetoAsistencia value
     * @throws \InvalidArgumentException
     * @param \wsas\StructType\ObjetoAsistencia $item
     * @return \wsas\ArrayType\ArrayOfObjetoAsistencia
     */
    public function addToObjetoAsistencia(\wsas\StructType\ObjetoAsistencia $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \wsas\StructType\ObjetoAsistencia) {
            throw new \InvalidArgumentException(sprintf('The ObjetoAsistencia property can only contain items of \wsas\StructType\ObjetoAsistencia, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ObjetoAsistencia[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \wsas\StructType\ObjetoAsistencia|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \wsas\StructType\ObjetoAsistencia|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \wsas\StructType\ObjetoAsistencia|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \wsas\StructType\ObjetoAsistencia|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \wsas\StructType\ObjetoAsistencia|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ObjetoAsistencia
     */
    public function getAttributeName()
    {
        return 'ObjetoAsistencia';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \wsas\ArrayType\ArrayOfObjetoAsistencia
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
