<?php

namespace wsas\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ObjetoAsistencia StructType
 * @subpackage Structs
 */
class ObjetoAsistencia extends AbstractStructBase
{
    /**
     * The COD_DEMANDA
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $COD_DEMANDA;
    /**
     * The NUM_ASISTENCIA
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $NUM_ASISTENCIA;
    /**
     * The ESTADO
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ESTADO;
    /**
     * The FECHA_ASISTENCIA
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FECHA_ASISTENCIA;
    /**
     * The HORA_ASISTENCIA
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $HORA_ASISTENCIA;
    /**
     * The VUELTA
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $VUELTA;
    /**
     * Constructor method for ObjetoAsistencia
     * @uses ObjetoAsistencia::setCOD_DEMANDA()
     * @uses ObjetoAsistencia::setNUM_ASISTENCIA()
     * @uses ObjetoAsistencia::setESTADO()
     * @uses ObjetoAsistencia::setFECHA_ASISTENCIA()
     * @uses ObjetoAsistencia::setHORA_ASISTENCIA()
     * @uses ObjetoAsistencia::setVUELTA()
     * @param float $cOD_DEMANDA
     * @param float $nUM_ASISTENCIA
     * @param int $eSTADO
     * @param string $fECHA_ASISTENCIA
     * @param string $hORA_ASISTENCIA
     * @param string $vUELTA
     */
    public function __construct($cOD_DEMANDA = null, $nUM_ASISTENCIA = null, $eSTADO = null, $fECHA_ASISTENCIA = null, $hORA_ASISTENCIA = null, $vUELTA = null)
    {
        $this
            ->setCOD_DEMANDA($cOD_DEMANDA)
            ->setNUM_ASISTENCIA($nUM_ASISTENCIA)
            ->setESTADO($eSTADO)
            ->setFECHA_ASISTENCIA($fECHA_ASISTENCIA)
            ->setHORA_ASISTENCIA($hORA_ASISTENCIA)
            ->setVUELTA($vUELTA);
    }
    /**
     * Get COD_DEMANDA value
     * @return float
     */
    public function getCOD_DEMANDA()
    {
        return $this->COD_DEMANDA;
    }
    /**
     * Set COD_DEMANDA value
     * @param float $cOD_DEMANDA
     * @return \wsas\StructType\ObjetoAsistencia
     */
    public function setCOD_DEMANDA($cOD_DEMANDA = null)
    {
        $this->COD_DEMANDA = $cOD_DEMANDA;
        return $this;
    }
    /**
     * Get NUM_ASISTENCIA value
     * @return float
     */
    public function getNUM_ASISTENCIA()
    {
        return $this->NUM_ASISTENCIA;
    }
    /**
     * Set NUM_ASISTENCIA value
     * @param float $nUM_ASISTENCIA
     * @return \wsas\StructType\ObjetoAsistencia
     */
    public function setNUM_ASISTENCIA($nUM_ASISTENCIA = null)
    {
        $this->NUM_ASISTENCIA = $nUM_ASISTENCIA;
        return $this;
    }
    /**
     * Get ESTADO value
     * @return int
     */
    public function getESTADO()
    {
        return $this->ESTADO;
    }
    /**
     * Set ESTADO value
     * @param int $eSTADO
     * @return \wsas\StructType\ObjetoAsistencia
     */
    public function setESTADO($eSTADO = null)
    {
        // validation for constraint: int
        if (!is_null($eSTADO) && !is_numeric($eSTADO)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($eSTADO)), __LINE__);
        }
        $this->ESTADO = $eSTADO;
        return $this;
    }
    /**
     * Get FECHA_ASISTENCIA value
     * @return string|null
     */
    public function getFECHA_ASISTENCIA()
    {
        return $this->FECHA_ASISTENCIA;
    }
    /**
     * Set FECHA_ASISTENCIA value
     * @param string $fECHA_ASISTENCIA
     * @return \wsas\StructType\ObjetoAsistencia
     */
    public function setFECHA_ASISTENCIA($fECHA_ASISTENCIA = null)
    {
        // validation for constraint: string
        if (!is_null($fECHA_ASISTENCIA) && !is_string($fECHA_ASISTENCIA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fECHA_ASISTENCIA)), __LINE__);
        }
        $this->FECHA_ASISTENCIA = $fECHA_ASISTENCIA;
        return $this;
    }
    /**
     * Get HORA_ASISTENCIA value
     * @return string|null
     */
    public function getHORA_ASISTENCIA()
    {
        return $this->HORA_ASISTENCIA;
    }
    /**
     * Set HORA_ASISTENCIA value
     * @param string $hORA_ASISTENCIA
     * @return \wsas\StructType\ObjetoAsistencia
     */
    public function setHORA_ASISTENCIA($hORA_ASISTENCIA = null)
    {
        // validation for constraint: string
        if (!is_null($hORA_ASISTENCIA) && !is_string($hORA_ASISTENCIA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hORA_ASISTENCIA)), __LINE__);
        }
        $this->HORA_ASISTENCIA = $hORA_ASISTENCIA;
        return $this;
    }
    /**
     * Get VUELTA value
     * @return string|null
     */
    public function getVUELTA()
    {
        return $this->VUELTA;
    }
    /**
     * Set VUELTA value
     * @param string $vUELTA
     * @return \wsas\StructType\ObjetoAsistencia
     */
    public function setVUELTA($vUELTA = null)
    {
        // validation for constraint: string
        if (!is_null($vUELTA) && !is_string($vUELTA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vUELTA)), __LINE__);
        }
        $this->VUELTA = $vUELTA;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \wsas\StructType\ObjetoAsistencia
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
